// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#pragma once

#include <memory>
#include <vector>

namespace verifone_sdk {

class Donation;
class Offer;

/**
 * Allows an application to propose changes to the basket using
 * {@link com.verifone.commerce.triggers.BasketAdjustmentResponse}.
 * When received in the {@link com.verifone.payment_sdk.BasketAdjustedEvent}, allows the
 * recipient to determine which adjustments will actually be applied to the cart.
 */
class BasketAdjustment {
public:
    virtual ~BasketAdjustment() {}

    static std::shared_ptr<BasketAdjustment> create();

    /** Returns true if any donations or offers have been added to the basket by the current application. */
    virtual bool isBasketAdjusted() const = 0;

    /**
     * Retrieves all of the offers that have been added to this response. Creates an array backed
     * by the underlying list.
     */
    virtual std::vector<std::shared_ptr<Offer>> getOffers() const = 0;

    /** Retrieves all of the donations that have been added to this response. */
    virtual std::vector<std::shared_ptr<Donation>> getDonations() const = 0;

    /** Adds an offer. */
    virtual void addOffer(const std::shared_ptr<Offer> & offer) = 0;

    /** Add list of offers to existed offers or create new list if no offers yet. */
    virtual void addOffers(const std::vector<std::shared_ptr<Offer>> & offers) = 0;

    /** Removes an offer from the list if it is present. Only affects offers added by the current application. */
    virtual void removeOffer(const std::shared_ptr<Offer> & offer) = 0;

    /** Adds a donation. */
    virtual void addDonation(const std::shared_ptr<Donation> & donation) = 0;

    /** Add list of donations to existed donations or create new list if no donations yet. */
    virtual void addDonations(const std::vector<std::shared_ptr<Donation>> & donations) = 0;

    /** Removes a donation from the list if it is present. Only affects donations added by the current application. */
    virtual void removeDonation(const std::shared_ptr<Donation> & donation) = 0;

    /** Set basket adjusted (in case of offers, donations, etc.) */
    virtual void setBasketAdjusted(bool adjusted) = 0;
};

}  // namespace verifone_sdk
