// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_entities.djinni

#pragma once

#include <cstdint>
#include <memory>
#include <optional>
#include <string>

namespace verifone_sdk {

enum class InstallmentType;
struct Decimal;

/** Data class encapsulating installment related information. Only applicable if the transaction is to be payed across installments. */
class Installment {
public:
    virtual ~Installment() {}

    static std::shared_ptr<Installment> create();

    /**
     * Returns the sequence associated with the installment
     * @return Integer representing the sequence.
     */
    virtual std::optional<int32_t> getSequence() const = 0;

    /** Returns the installment type. */
    virtual std::optional<InstallmentType> getInstallmentType() const = 0;

    /** The total number of payments */
    virtual std::optional<int32_t> getTotalNumberPayments() const = 0;

    /** The total amount to be paid. */
    virtual std::optional<Decimal> getTotalAmount() const = 0;

    /** The first payment amount. */
    virtual std::optional<Decimal> getFirstPaymentAmount() const = 0;

    /** Gets the first payment timestamp */
    virtual std::optional<std::string> getFirstPaymentDate() const = 0;

    /**
     * Gets the plan ID associated this installment.
     * @return A String representing the plan ID.
     */
    virtual std::optional<std::string> getPlanId() const = 0;

    /** Refer to {@link #getSequence()} */
    virtual void setSequence(std::optional<int32_t> sequence) = 0;

    /** Refer to {@link #getInstallmentType()} */
    virtual void setInstallmentType(std::optional<InstallmentType> installmentType) = 0;

    /** Refer to {@link #getTotalNumberPayments()} */
    virtual void setTotalNumberPayments(std::optional<int32_t> totalPayments) = 0;

    /** Refer to {@link #getTotalAmount()} */
    virtual void setTotalAmount(const std::optional<Decimal> & totalAmount) = 0;

    /** Refer to {@link #getFirstPaymentAmount()} */
    virtual void setFirstPaymentAmount(const std::optional<Decimal> & firstPaymentAmount) = 0;

    /** Refer to {@link #getFirstPaymentDate()} */
    virtual void setFirstPaymentDate(const std::optional<std::string> & firstPaymentDate) = 0;

    /** Refer to {@link #getPlanId()} */
    virtual void setPlanId(const std::optional<std::string> & planId) = 0;
};

}  // namespace verifone_sdk
