// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment_reports.djinni

#pragma once

#include <cstdint>
#include <optional>
#include <string>

namespace verifone_sdk {

/** Represents a single reconciliation, providing the ID and other relevant information. */
class Reconciliation {
public:
    virtual ~Reconciliation() {}

    /**
     * The ID for this reconciliation, to be used with APIs like
     * {@link ReportManager#getPreviousReconciliation(String)}.
     */
    virtual std::string getId() const = 0;

    /**
     * Returns a the date and time for this reconciliation ID, allowing for a logical ordering
     * of the IDs. Follows ISO 8601 date/time extended standard format
     * {@code yyyy '-' mm '-' dd 'T' hh ':' mm ':' ss ('.' sss)? zzzzzz}, e.g.,
     * {@code 2008-04-12T22:20:50.275+01:00}.
     */
    virtual std::string getTimestamp() const = 0;

    /**
     * Returns a Boolean indicating if this reconciliation is completely settled, false if it's
     * still pending, or null if unknown. Some hosts do not provide this information.
     */
    virtual std::optional<bool> isSettled() const = 0;

    /**
     * Returns the acquirer ID associated with this reconciliation in a multi-acquirer
     * environment and if known, otherwise this is null.
     */
    virtual std::optional<int32_t> getAcquirerId() const = 0;
};

}  // namespace verifone_sdk
